#include <stdlib.h>
#include <stdio.h>
#include <windows.h>
#include <math.h>
#include <string.h>

#include "entropykey.h"
#pragma comment (lib, "EntropyKey.lib")

#pragma warning(disable:4996)

//---------------------------------------------------------------------------

int main(int argc, char* argv[])
{
	int		keysfound;
	int		i;
	BOOL	result_B;
	BOOL	used_ekey;
	BYTE	r_byte_buf[100000];
	BYTE	r_byte;
	__int8	r_int8;
	short	r_short;
	int		r_int;
	__int64	r_int64;
	float	r_float;
	double	r_double;
	int		num_bits, num_bytes;

	printf("Entropy Key Test\n");
	printf("================\n\n");

	ekey_log_fptr = stdout;
	ekey_dat_fptr = NULL;

	keysfound = ekey_connect();

	printf("Keys found = %d\n\n", keysfound);

	// wait until entropy available in pool
	while(ekey_get_bytes_available() < ((2000 * keysfound) > POOLSIZE ? POOLSIZE : 2000 * keysfound));

	num_bytes = ekey_get_bytes(r_byte_buf, 2000, TRUE, &used_ekey);
	for(i=0;i<2000;i++) printf(" %02x", r_byte_buf[i]);

//	num_bits = ekey_get_bits(r_byte_buf, 10000, TRUE, &used_ekey);
//	for(i=0;i<10000;i++) printf("%1d", r_byte_buf[i]);

	for(i=0;i<100;i++)
	{
//		result_B = ekey_get_int8((__int8*)&r_byte, TRUE, &used_ekey);
//		printf("%4d: %20d - %s <<%s>>\n", i, r_byte, result_B ? "TRUE " : "FALSE", used_ekey ? "TRUE" : "FALSE");

//		result_B = ekey_get_int8(&r_int8, TRUE, &used_ekey);
//		printf("%4d: %20d - %s <<%s>>\n", i, r_int8, result_B ? "TRUE " : "FALSE", used_ekey ? "TRUE" : "FALSE");

//		result_B = ekey_get_int16(&r_short, TRUE, &used_ekey);
//		printf("%4d: %20d - %s <<%s>>\n", i, r_short, result_B ? "TRUE " : "FALSE", used_ekey ? "TRUE" : "FALSE");

//		result_B = ekey_get_int32(&r_int, TRUE, &used_ekey);
//		printf("%4d: %20d - %s <<%s>>\n", i, r_int, result_B ? "TRUE " : "FALSE", used_ekey ? "TRUE" : "FALSE");

//		result_B = ekey_get_int64(&r_int64, TRUE, &used_ekey);
//		printf("%4d: %20lld - %s <<%s>>\n", i, r_int64, result_B ? "TRUE " : "FALSE", used_ekey ? "TRUE" : "FALSE");

//		result_B = ekey_get_int_range(&r_int, -1000000000, 1000000000, FALSE, TRUE, &used_ekey);
//		printf("%4d: %15d - %s <<%s>>\n", i, r_int, result_B ? "TRUE " : "FALSE", used_ekey ? "TRUE" : "FALSE");

//		result_B = ekey_get_float(&r_float, 8, TRUE, &used_ekey);
//		printf("%4d: %30.20e - %s <<%s>>\n", i, r_float, result_B ? "TRUE " : "FALSE", used_ekey ? "TRUE" : "FALSE");

//		result_B = ekey_get_double(&r_double, 11, TRUE, &used_ekey);
//		printf("%4d: %30.20e - %s <<%s>>\n", i, r_double, result_B ? "TRUE " : "FALSE", used_ekey ? "TRUE" : "FALSE");

//		result_B = ekey_get_double(&r_double, 1, TRUE, &used_ekey);
//		printf("%4d: %30.20e - %s <<%s>>\n", i, r_double, result_B ? "TRUE " : "FALSE", used_ekey ? "TRUE" : "FALSE");

//		result_B = ekey_get_double01(&r_double, TRUE, &used_ekey);
//		printf("%4d: %30.20f - %s <<%s>>\n", i, r_double, result_B ? "TRUE " : "FALSE", used_ekey ? "TRUE" : "FALSE");
	}

	printf("\nPress any key to exit\n\n");
	getc(stdin);

	ekey_disconnect();

	return 0;
}
//---------------------------------------------------------------------------
